package com.scbfkj.uni.library;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DbUtil {

    private static final Map<String, List<String>> columns = new HashMap<>();

    public static List<String> getColumns(String connection,String sql, ResultSet resultSet) throws SQLException {
        if (columns.containsKey(connection+sql)) {
            return columns.get(sql);
        }

        ArrayList<String> cs = new ArrayList<>();
        ResultSetMetaData metaData = resultSet.getMetaData();
        for (int i = 0; i < metaData.getColumnCount(); i++) {
            cs.add(metaData.getColumnName(i));
        }

        columns.put(sql, cs);
        return cs;

    }

    public static List<Map<String, Object>> getResult(String connection, String sql, ResultSet resultSet) throws SQLException {
        List<String> cs = getColumns(connection,sql, resultSet);

        List<Map<String, Object>> result = new ArrayList<>();
        while (resultSet.next()) {
            Map<String, Object> resultMap = new HashMap<>();
            for (String c : cs) {
                Object object = resultSet.getObject(c);
                resultMap.put(c, object);
            }
            result.add(resultMap);
        }
        return result;

    }
}
